/*
 * Copyright (c) 2015, University of Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Janik Schlemminger
 *    Robert Gernhardt
 *    Matthias Jung
 */

#ifndef TRANSACTION_H
#define TRANSACTION_H
#include <vector>
#include <memory>
#include "timespan.h"
#include "phases/phase.h"
#include "presentation/tracedrawingproperties.h"

typedef unsigned int ID;

class Transaction
{
private:
    unsigned int address, burstlength, thread, channel, bank, bankgroup, row,
             column;
    Timespan span;
    Timespan spanOnDataStrobe;
    ID id;
    std::vector<std::shared_ptr<Phase>> phases;

public:
    Transaction(ID id, unsigned int address, unsigned int burstlength,
                unsigned int thread, unsigned int channel, unsigned int bank,
                unsigned int bankgroup, unsigned int row, unsigned int column, Timespan span,
                Timespan spanOnDataStrobe);

    void draw(QPainter *painter, const QwtScaleMap &xMap, const QwtScaleMap &yMap,
              const QRectF &canvasRect, bool highlight,
              const TraceDrawingProperties &drawingProperties) const;
    void addPhase(std::shared_ptr<Phase> phase);

    bool isSelected(traceTime time, double yVal,
                    const TraceDrawingProperties &drawingproperties) const;

    unsigned int Address() const
    {
        return address;
    }
    unsigned int Burstlength() const
    {
        return burstlength;
    }
    unsigned int Thread()
    {
        return thread;
    }
    unsigned int Channel() const
    {
        return channel;
    }
    unsigned int Bank() const
    {
        return bank;
    }
    unsigned int BankGroup() const
    {
        return bankgroup;
    }
    unsigned int Row() const
    {
        return row;
    }
    unsigned int Column() const
    {
        return column;
    }
    ID Id() const
    {
        return id;
    }
    const Timespan &Span() const
    {
        return span;
    }
    const Timespan &SpanOnDataStrobe()
    {
        return spanOnDataStrobe;
    }
    const std::vector<std::shared_ptr<Phase>> &Phases() const
    {
        return phases;
    }
};

#endif // TRANSACTION_H
